using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

/* =============================================================================
 * Function   : ET_CheckPwdz201
 * Description: OTP Z201(TOTP) ֤ӿ
 * Parameter  : 
 *		authkey			Կ
 *      t               ǰʱUTC Epoch
 *      t0              ʼοʱUTC Epoch(ĬΪ0)
 *      x               TOTP仯(ĬΪ60)
 *      drift           Ưƴ
 *      authwnd		    ֤Χ, ͨ0-20
 *      lastsucc        ǰһ֤ɹUTC Epoch(ΪֹطŹ)
 *      otp				Ҫ֤Ķ̬
 *      otplen			Ҫ֤Ķ̬, ͨ6
 *      currsucc		֤ɹUTC Epoch
 *      currdft         ֤ɹĵǰƯƴ
 *
 * return     : 0 - ɹ, ֵΪ.
 *
 *int __stdcall ET_CheckPwdz201(char *authkey, uint64_t t, uint64_t t0, 
 *   unsigned int x, int drift, int authwnd, uint64_t lastsucc, 
 *   const char *otp, int otplen, uint64_t *currsucc, int *currdft);
 */

/* =============================================================================
 * Function   : ET_Syncz201
 * Description: OTP Z201(TOTP) ͬӿ
 * Parameter  : 
 *		authkey			ԿѾܹģҪн
 *      t               ǰʱUTC Epoch
 *      t0              ʼοʱUTC Epoch(ĬΪ0)
 *      x               TOTP仯(ĬΪ60)
 *      drift           Ưƴ
 *      syncwnd         ͬΧ, ͨ0-20
 *      lastsucc        ǰһ֤ɹUTC Epoch(ΪֹطŹ)
 *      otp1            Ҫͬĵһ̬
 *      otp1len			Ҫͬĵһ̬, ͨ6
 *      otp2            Ҫͬĵڶ̬
 *      otp2len         Ҫͬĵڶ̬, ͨ6
 *      currsucc		֤ɹUTC Epoch
 *      currdft         ֤ɹĵǰƯƴ
 *
 * return     : 0 - ɹ, ֵΪ.
 
 *int __stdcall ET_Syncz201(char *authkey, uint64_t t, uint64_t t0, 
 *      unsigned int x, int drift, int syncwnd, uint64_t lastsucc, 
 *      const char *otp1, int otp1len, const char *otp2, int otp2len, 
 *      uint64_t *currsucc, int *currdft);
 */

namespace Test
{


    public partial class Form1 : Form
    {

        [DllImport("ET_OTPVerify.dll")]
        public static extern int ET_CheckPwdz201(string authkey, UInt64 t, UInt64 t0, uint x, int drift, int authwnd, UInt64 lastsucc, string otp, int otplen, ref UInt64 currsucc, ref int currdft);


        [DllImport("ET_OTPVerify.dll")]
        public static extern int ET_Syncz201(string authkey, UInt64 t, UInt64 t0, uint x, int drift, int syncwnd, UInt64 lastsucc, string otp1, int otp1len, string otp2, int otp2len, ref UInt64 currsucc, ref int currdft);

        UInt64 currsucc1 = 0;
        int currdft1 = 0;

        public Form1()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            string otp1, otp2;
            otp1 = this.textBox2.Text;
            otp2 = this.textBox3.Text;

            int iRe = 0;

            string authkey = "ll598C28E54BF3C58EC35E830655A139861407519FCBC92140";

            UInt64 currsucc = 0;
            int currdft = 0;

            //z201ʱOTP֤
            TimeSpan tsTimeSpan = DateTime.UtcNow - new DateTime(1970, 1, 1);
            ulong ulgTimeStamp = (ulong)tsTimeSpan.TotalSeconds;

            iRe = ET_Syncz201(authkey, ulgTimeStamp, 0, 60, currdft1, 60, currsucc1, otp1, 6, otp2, 6, ref currsucc, ref currdft);
            if (iRe == 0)
            {
                MessageBox.Show("ͬɹ");

                currsucc1 = currsucc;
                currdft1 = currdft;
            }
            else
            {
                MessageBox.Show("ͬʧܣ");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string otp;
            otp = this.textBox1.Text;

            int iRe = 0;

            string authkey = "ll598C28E54BF3C58EC35E830655A139861407519FCBC92140";

            UInt64 currsucc = 0;
            int currdft = 0;

            TimeSpan tsTimeSpan = DateTime.UtcNow - new DateTime(1970, 1, 1);
            ulong ulgTimeStamp = (ulong)tsTimeSpan.TotalSeconds;

            iRe = ET_CheckPwdz201(authkey, ulgTimeStamp, 0, 60, currdft1, 40, currsucc1, otp, 6, ref currsucc, ref currdft);
            if (iRe == 0)
            {
                MessageBox.Show("֤ɹ");

               currsucc1 = currsucc;
               currdft1 = currdft;
            }
            else
            {
                MessageBox.Show("֤ʧܣ");
            }
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < 48 || e.KeyChar > 57) && e.KeyChar != 8)
                e.Handled = true;
        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < 48 || e.KeyChar > 57) && e.KeyChar != 8)
                e.Handled = true;
        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((e.KeyChar < 48 || e.KeyChar > 57) && e.KeyChar != 8)
                e.Handled = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}